//IonLauncher.cs

//audio
datablock AudioProfile(IonLauncherShot1Sound)
{
   filename    = "./IonLauncherFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(IonLauncherExplosionSound)
{
   filename    = "./IonLauncherHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(IonLauncherSwitchSound)
{
   filename    = "./IonLauncherSwitch.wav";
   Description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(IonLauncherChargeSound)
{
   filename    = "./IonLauncherCharge.wav";
   Description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(IonLauncherLaserLoopSound)
{
   filename    = "./IonLauncherLoop.wav";
   Description = AudioFar3d;
   preload = true;
};

//shell
datablock DebrisData(IonLauncherShellDebris)
{
	shapeFile = "./shapes/gunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


//muzzle flash effects
datablock ParticleData(IonLauncherFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.3 0.9 1.0 0.9";
	colors[1]     = "0.0 0.5 0.9 0.0";
	sizes[0]      = 9.5;
	sizes[1]      = 10.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(IonLauncherFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IonLauncherFlashParticle";
};

datablock ParticleData(IonLauncherSmokeParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 55;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.6 0.6 0.6 0.9";
	colors[1]     = "0.6 0.6 0.6 0.0";
	sizes[0]      = 2.15;
	sizes[1]      = 1.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(IonLauncherSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 2.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IonLauncherSmokeParticle";
};
datablock ParticleData(IonLauncherChargeParticle1)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 55;
	lifetimeVarianceMS   = 55;
	textureName          = "./shapes/lightningbolt";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.0 0.6 0.9";
	colors[1]     = "0.0 0.0 0.6 0.0";
	sizes[0]      = 8.15;
	sizes[1]      = 8.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(IonLauncherChargeEmitter1)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 2.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IonLauncherChargeParticle1";
};

datablock ParticleData(IonLauncherChargeParticle2)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 3;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0.0;
	textureName          = "./shapes/adjustedRing";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "173.5 173.5 173.5 170";
	colors[1]     = "100 100 100 100";
	sizes[0]      = 15.0;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(IonLauncherChargeEmitter2)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 1;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.2;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IonLauncherChargeParticle2";
};

//bullet trail effects
datablock ParticleData(IonLauncherTrailParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 2025;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/thinRing";
	spinSpeed		= 300.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.3 0.9 0.4";
	colors[1]     = "0.0 0.0 0.1 0.0";
	sizes[0]      = 10.15;
	sizes[1]      = 12.25;

	useInvAlpha = false;
};
datablock ParticleEmitterData(IonLauncherTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IonLauncherTrailParticle";
};


datablock ParticleData(IonLauncherExplosionParticle1)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 5.0;
	lifetimeMS           = 2000;
	lifetimeVarianceMS   = 200;
	textureName          = "add-ons/shapes/Lightning";
	spinSpeed		= 100.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.01 0.01 0.01 0.9";
	colors[1]     = "0.0 0.5 0.9 0.0";
	sizes[0]      = 50.0;
	sizes[1]      = 55.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(IonLauncherExplosionEmitter1)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IonLauncherExplosionParticle1";
};

datablock ParticleData(IonLauncherPowerSurgeParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 3.0;
	constantAcceleration = 5.0;
	lifetimeMS           = 10;
	lifetimeVarianceMS   = 10;
	textureName          = "./shapes/Lightningbolt";
	spinSpeed		= 100.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.0 0.0 0.9 0.9";
	colors[1]     = "0.0 0.0 0.5 0.0";
	sizes[0]      = 20.0;
	sizes[1]      = 1000.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(IonLauncherPowerSurgeEmitter)
{
   ejectionPeriodMS = 1000;
   periodVarianceMS = 2000;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IonLauncherPowerSurgeParticle";
};

datablock ParticleData(IonLauncherExplosionRingParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 5.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.5 0.2 0.5";
	colors[1]     = "0.0 0.0 0.7 0.0";
	sizes[0]      = 8;
	sizes[1]      = 13;

	useInvAlpha = false;
};
datablock ParticleEmitterData(IonLauncherExplosionRingEmitter)
{
	lifeTimeMS = 500;

   ejectionPeriodMS = 0;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 5.0;
   ejectionOffset   = 10.0;
   thetaMin         = 180;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IonLauncherExplosionRingParticle";
};

datablock ExplosionData(IonLauncherExplosion)
{
   //explosionShape = "";
   explosionShape = "./shapes/IonLauncherLaserExplosion.dts";
	soundProfile = IonLauncherExplosionSound;

   lifeTimeMS = 1000;

   ParticleEmitter = IonLauncherExplosionEmitter1;
   particleDensity = 100;
   particleRadius = 100;

   emitter[0] = IonLauncherExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "10 10 10";

   shakeCamera = true;
   camShakeFreq = "34.0 38.0 34.0";
   camShakeAmp = "25.0 30.0 25.0";
   camShakeDuration = 0.5;
   camShakeRadius = 300.0;

   // Dynamic light
   lightStartRadius = 500;
   lightEndRadius = 300;
   lightStartColor = "0 0 1 0.5";
   lightEndColor = "0 0 0 0";

   damageRadius = 100;
   radiusDamage = 200;

   impulseRadius = 200;
   impulseForce = 15000;
};

datablock ProjectileData(IonLauncherProjectile)
{
   projectileShapeName = "./shapes/IonLauncherLaser.dts";
   directDamage        = 500;
   directDamageType    = $DamageType::IonLauncherDirect;
   radiusDamageType    = $DamageType::IonLauncherRadius;

   brickExplosionRadius = 100;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 120;
   brickExplosionMaxVolume = 9999;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 9999;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1500;
   verticalImpulse	  = 3000;
   explosion           = IonLauncherExplosion;
   particleEmitter     = IonLauncherTrailEmitter;

   sound = IonLauncherLaserLoopSound;

   muzzleVelocity      = 500;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 10000;
   fadeDelay           = 3500;
   bounceElasticity    = 4;
   bounceFriction      = 6.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 20.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(IonLauncherItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/IonLauncher.dts";
	rotate = true;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "IonLauncher";
	iconName = "./Shapes/IonLauncher";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = IonLauncherImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(IonLauncherImage)
{
   // Basic Item properties
   shapeFile = "./shapes/IonLauncher.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = IonLauncherProjectile;
   projectileType = Projectile;

	casing = IonLauncherShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = IonLauncherItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]			 = IonLauncherSwitchSound;

	stateName[1]                     = "Ready";
	stateEmitter[1]			 = IonLauncherPowerSurgeEmitter;
	stateEmitterNode[1]		 = "muzzleNode";
	stateTransitionOnTriggerDown[1]  = "Prefire";
	stateAllowImageChange[1]         = true;


	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = true;
	stateSound[2]			= IonLauncherChargeSound;
	stateTimeoutValue[2]            = 1;
	stateTransitionOnTimeout[2]     = "DissengageLock";
	stateAllowImageChange[2]	="true";
	stateEmitter[2]			= IonLauncherChargeEmitter2;
	stateEmitterTime[2]		= 5;
	stateEmitterNode[2]		="muzzleNode";

	stateName[3]			= "DissengageLock";
	stateScript[3]			= "onDissengageLock";
	stateAllowImageChange[3]	= true;
	stateTimeOutValue[3]		= 2;
	stateTransitionOnTimeout[3]	= "Fire";
	stateAllowImageChange[3]	= "true";
	stateEmitter[3]			= IonLauncherChargeEmitter1;
	stateEmitterTime[3]		= 2;
	stateEmitterNode[3]		="muzzleNode";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "Smoke";
	stateTimeoutValue[4]            = 0.05;
	stateAllowImageChange[4]        = true;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]		= true;
	stateFire[4]                    = true;

	stateEmitter[4]			= IonLauncherFlashEmitter;
	stateEmitterTime[4]		= 0.05;
	stateEmitterNode[4]		= "muzzleNode";
	stateSound[4]			= IonLauncherShot1Sound;

	stateName[5] 			= "Smoke";
	stateEmitter[5]			= IonLauncherSmokeEmitter;
	stateEmitterTime[5]		= 4;
	stateEmitterNode[5]		= "muzzleNode";
	stateTimeoutValue[5]            = 4;
	stateTransitionOnTimeout[5]     = "Reload";
	stateSound[5]			 = IonLauncherReloadSound;

	stateName[6]			= "Reload";
	stateSequence[6]                = "Reload";
	stateTransitionOnTriggerUp[6]     = "Ready";
	stateSequence[6]		= "Ready";

};